<p align="center"> 
  <br/>  
  <a href="https://opensource.org/license/agpl-v3"><img src="https://img.shields.io/badge/License-AGPL_v3-blue.svg?color=3F51B5&style=for-the-badge&label=License&logoColor=000000&labelColor=ececec" alt="License: AGPLv3"></a>
  <a href="https://discord.gg/D8JsnBEuKb">
    <img src="https://img.shields.io/discord/979116623879368755.svg?label=Discord&logo=Discord&style=for-the-badge&logoColor=000000&labelColor=ececec" atl="Discord"/>
  </a>
  <br/>  
  <br/>   
</p>

<p align="center">
<img src="design/immich-logo.svg" width="150" title="Login With Custom URL">
</p>
<h3 align="center">Immich - Solution de sauvegarde performante et auto-hébergée des photos et des vidéos</h3>
<br/>
<a href="https://immich.app">
<img src="design/immich-screenshots.png" title="Main Screenshot">
</a>
<br/>
<p align="center">
  <a href="README.md">English</a>
  <a href="README_ca_ES.md">Català</a>
  <a href="README_es_ES.md">Español</a>
  <a href="README_it_IT.md">Italiano</a>
  <a href="README_ja_JP.md">日本語</a>
  <a href="README_ko_KR.md">한국어</a>
  <a href="README_de_DE.md">Deutsch</a>
  <a href="README_nl_NL.md">Nederlands</a>
  <a href="README_tr_TR.md">Türkçe</a>
  <a href="README_zh_CN.md">中文</a>
</p>

## Clause de non-responsabilité

- ⚠️ Le projet est en **très fort** développement.
- ⚠️ Attendez-vous à rencontrer des bugs et des changements importants.
- ⚠️ **N'utilisez pas cette application comme seule façon de sauvegarder vos photos et vos vidéos.**
- ⚠️ Ayez toujours un plan de sauvegarde en [3-2-1](https://www.seagate.com/fr/fr/blog/what-is-a-3-2-1-backup-strategy/) pour vos précieuses photos et vidéos !

## Sommaire

- [Documentation officielle](https://immich.app/docs)
- [Feuille de route](https://github.com/orgs/immich-app/projects/1)
- [Démo](#demo)
- [Fonctionnalités](#features)
- [Introduction](https://immich.app/docs/overview/introduction)
- [Installation](https://immich.app/docs/install/requirements)
- [Contribution](https://immich.app/docs/overview/support-the-project)
- [Soutenir le projet](#support-the-project)

## Documentation

Vous pouvez trouver la documentation principale ainsi que les guides d'installation sur https://immich.app/.

## Démo

Vous pouvez accéder à la démo Web sur https://demo.immich.app

Pour l'application mobile, vous pouvez utiliser `https://demo.immich.app/api` dans le champ 'URL du point d'accès au serveur'

```bash title="Demo Credential"
Les identifiants
email: demo@immich.app
mot de passe: demo
```

```
Caractéristiques: Plan gratuit Oracle VM - Amsterdam - 2.4Ghz quatre-cœurs ARM64 CPU, 24GB RAM
```

# Fonctionnalités

| Fonctionnalités                                                  | Mobile | Web |
| ---------------------------------------------------------------- | ------ | --- |
| Téléverser et voir les vidéos et photos                          | Oui    | Oui |
| Sauvegarde automatique quand l'application est ouverte           | Oui    | N/A |
| Sélection des albums à sauvegarder                               | Oui    | N/A |
| Télécharger les photos et les vidéos sur l'appareil              | Oui    | Oui |
| Support multi-utilisateur                                        | Oui    | Oui |
| Albums et albums partagés                                        | Oui    | Oui |
| Barre de défilement mobile                                       | Oui    | Oui |
| Support des formats raw                                          | Oui    | Oui |
| Vue sur les métadonnées (EXIF, carte)                            | Oui    | Oui |
| Rechercher par métadonnées, objets, faces et CLIP                | Oui    | Oui |
| Fonctions d'administration (gestion des utilisateurs)            | Non    | Oui |
| Sauvegarde en tâche de fond                                      | Oui    | N/A |
| Défilement virtuel                                               | Oui    | Oui |
| Support de l'OAuth                                               | Oui    | Oui |
| Clés d'API                                                       | N/A    | Oui |
| Sauvegarde et lecture des LivePhotos                             | iOS    | Oui |
| Structure de stockage définissable                               | Oui    | Oui |
| Partage public                                                   | Non    | Oui |
| Archives et favoris                                              | Oui    | Oui |
| Carte globale                                                    | Non    | Oui |
| Partage entre utilisateurs                                       | Oui    | Oui |
| Reconnaissance et regroupement facial                            | Oui    | Oui |
| Souvenirs (il y a x années)                                      | Oui    | Oui |
| Support hors-ligne                                               | Oui    | Non |
| Gallerie en lecture seule                                        | Oui    | Oui |

# Soutenir le projet

Je me suis engagé sur ce projet, et je ne compte pas m'arrêter. Je continuerai à mettre à jour les documentations, d'ajouter de nouvelles fonctionnalités et de résoudre des bugs. Mais je ne peux pas faire cela seul. Donc j'ai besoin de votre aide pour me donner encore plus de motivation et ainsi continuer.

Comme l'ont dit nos hôtes dans le [selfhosted.show - Dans l'épisode 'The-organization-must-not-be-name is a Hostile Actor'](https://selfhosted.show/79?t=1418), c'est un travail colossal ce que l'équipe et moi faisons. J'aimerais un jour être capable de faire ça à temps plein, c'est pourquoi je vous demande votre aide pour rendre cela possible.

Si vous estimez que c'est pour la bonne cause et que vous prévoyez d'utiliser l'application pour un moment, s'il-vous-plaît, pensez à soutenir le projet avec les moyens ci-dessous.

## Donation

- [Donation mensuelle](https://github.com/sponsors/immich-app) via GitHub Sponsors
- [Donation occasionnelle](https://github.com/sponsors/immich-app?frequency=one-time&sponsor=alextran1502) via GitHub Sponsors
- [Librepay](https://liberapay.com/alex.tran1502/)
- [buymeacoffee](https://www.buymeacoffee.com/altran1502)
- Bitcoin: 3QVAb9dCHutquVejeNXitPqZX26Yg5kxb7
- ZCash: u1smm4wvqegcp46zss2jf5xptchgeczp4rx7a0wu3mermf2wxahm26yyz5w9mw3f2p4emwlljxjumg774kgs8rntt9yags0whnzane4n67z4c7gppq4yyvcj404ne3r769prwzd9j8ntvqp44fa6d67sf7rmcfjmds3gmeceff4u8e92rh38nd30cr96xw6vfhk6scu4ws90ldzupr3sz
